/*============================================================================
//	aPCI8815 Tv\tgQ
//
//	aPCI8815ɂTvOs
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1998/10/26
//
//	TvF	荞݂𗘗pTvOs܂B
//
//	@uAPCICTRL.CvƁuSAMPLE2.CvRpC^NĂgpB
//
//	RpC@F
//		TC++4.0̏ꍇ	tcc -ml sample1.c apcictrl.c
//		MS-C6.0̏ꍇ	cl /AL sample1.c apcictrl.c
//
//	ӁF
//	@{vOTC++4.0/MS-C6.0œmFsĂ܂B
//	̑RpCgp̏ꍇ̓TvvȌCKvɂȂꍇ
//	L܂B
//	@{vO͂lr|cnrœ\Ȏst@C𐶐łRpC
//	ł̂݃RpC\łB
//
//===========================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include "typedef.h"
#include "apci8815.h"

/*---------- X^eBbNϐ -----------------------------------------------*/
static APCI_FIND_RES h8815;

#ifdef	_MSC_VER
	#define __CPPARGS
	static void (interrupt far *OldVect)();		/* 荞݃xN^ */

#elif __BORLANDC__ || __TURBOC__
	#ifdef __cplusplus
		#define __CPPARGS ...
	#else
		#define __CPPARGS
	#endif
	static void interrupt(*OldVect)(__CPPARGS);	/* 荞݃xN^ */
#endif

static uchar	cbOldImr;					/* 荞݋BIT */

typedef struct tagINTR_DATA
{
	ushort	wData;				/* ̓f[^ */
	boolean	InFlg;				/* 荞ݔtO */
} INTR_DATA;

static INTR_DATA InAd;			/* 荞ݓŐݒ肳A/D̓f[^ */

static int	  nSmpMode;			/* TvO[h */
static int	  nSmpFrstCH;		/* Jn`l */
static int	  nSmpLastCH;		/* I`l */
static ulong  dwSmpTime;		/* TvO^C} */
static ushort wCtrl;			/* 8815䃌WX^l */

/*---------- X^eBbN֐ -----------------------------------------------*/
static int	  GetParam(int argc, char *argv[]);
static void	  DispHelp(void);
static int	  Init8815(void);
static void	  Term8815(void);
static int	  GetVectNo(int iIrq);
static ushort GetImr(int iIrq);
static uchar  GetIrqBit(int iIrq);
static void	  interrupt Intr8815(__CPPARGS);
static void	  SetSamplingMode(void);
static uchar  TimerToTWData(char* pbE0, char* pbE1);
static void	  StartSampling(void);
static void	  StopSampling(void);

#if defined(_MSC_VER)
	#if defined(NDEBUG)					/* [X[hRpC */
		#pragma optimize("egl", off)	/* ̍œKȂ */
	#endif
#endif


/*============================================================================
//	C
//===========================================================================*/
int main(int argc, char* argv[])
{
	int nkbhit = 0;
	long i;

	/* p[^擾 */
	if (GetParam(argc, argv) == -1)
		return -1;

	/*  */
	if (Init8815() == -1)
		return -1;

	printf("\033[>5h\n");		/* J[\OFF */

	/* TvOp[^ݒ */
	SetSamplingMode();

	/* wait */
	for (i = 0; i < 1000000L; i++);

	/* TvOJn */
	StartSampling();

	InAd.InFlg = FALSE;

	/* 荞݉񐔃JEg */
	while (!(nkbhit = kbhit()))
	{
		if (!InAd.InFlg)
			continue;

		InAd.InFlg = FALSE;

		printf("  %04Xh ", InAd.wData);

		/* VOTvO */
		if (nSmpMode == APCI8815_MODE_01 || nSmpMode == APCI8815_MODE_02)
			break;
	}

	/* TvOXgbv */
	StopSampling();

	printf("\033[>5l");			/* J[\ON */

	if (nkbhit != 0)
		getch();

	/* I */
	Term8815();

	/* I */
	printf("\n");
	return 0;
}

/*============================================================================
//	p[^擾
//===========================================================================*/
static int GetParam(int argc, char *argv[])
{
	if (argc < 4)
	{
		DispHelp();
		return -1;
	}

	/* [h */
	nSmpMode = atoi(argv[1]);
	if (nSmpMode < APCI8815_MODE_01 || nSmpMode > APCI8815_MODE_04)
	{
		printf("Mode Error.\n");
		return -1;
	}

	/* `l */
	nSmpFrstCH = atoi(argv[2]);		/* Jn`l */
	nSmpLastCH = atoi(argv[3]);		/* I`l */
	if (nSmpFrstCH < APCI8815_CH_FIRST || nSmpFrstCH > APCI8815_CH_LAST ||
		nSmpLastCH < APCI8815_CH_FIRST || nSmpLastCH > APCI8815_CH_LAST ||
		nSmpFrstCH > nSmpLastCH)
	{
		printf("Channel Error.\n");
		return -1;
	}

	/* ^C} */
	if (nSmpMode == APCI8815_MODE_03)
	{
		if (argc < 5)
		{
			printf("There is no Time Parameter.\n");
			return -1;
		}

		dwSmpTime = (ulong)atol(argv[4]);
		if (dwSmpTime < APCI8815_TM_MIN || dwSmpTime > APCI8815_TM_MAX)
		{
			printf("Time Error.\n");
			return -1;
		}
	}

	return 0;
}

/*============================================================================
//	p[^\
//===========================================================================*/
static void DispHelp(void)
{
	printf("Sampling Test Parameter\n"
		   "Sample2  ݸӰ Jn I []\n\n"
		   "  ݸӰ (1-4)  Mode Sampling CLK\n"
		   "  \t\t      1:   single   ---\n"
		   "  \t\t      2:   single   EXTRG\n"
		   "  \t\t      3:   burst    timer\n"
		   "  \t\t      4:   burst    EXTRG\n"
		   "  Jn    (0-15)\n"
		   "  I    (0-15) { Jn <= I }\n"
		   "            (12-64000000ns)\n"
		   );
}

/*============================================================================
//	
//============================================================================*/
static int Init8815(__CPPARGS)
{
	int		iVno;
	ushort	wImr;
	uchar	cbBit;

	/* Gg[擾 */
	if (ApciGetDriverFunc() == -1)
	{
		printf("hCõGg[擾ł܂łB\n");
		return -1;
	}

	/* foCX擾 */
	if (ApciGetDeviceInfo(&h8815, APCI8815_BOARD_ID, 0) != CMD_COMPLETE)
	{													/* 擾łȂ */
		printf("foCX܂B\n");
		return -1;
	}

	/* 荞ݐ */
	if (h8815.wNumIRQs <= 0)
	{
		printf( "荞݂gpł܂\n");
		return -1;
	}

	iVno = GetVectNo(h8815.bIRQRegisters);	/* 荞ݔԍ擾 */
	wImr = GetImr(h8815.bIRQRegisters);		/* 荞݃}XNWX^擾 */
	cbBit= GetIrqBit(h8815.bIRQRegisters);	/* 荞݋rbg擾 */

	disable();
	OldVect	 = getvect(iVno);				/* ݂̊荞݃xN^擾 */
	cbOldImr = inportb(wImr);				/* ݂̊荞݋rbg擾 */
	outportb(wImr, (cbOldImr & ~cbBit));	/* 荞݋rbgݒ */
	setvect(iVno, Intr8815);				/* 荞݃xN^ݒ */
	enable();

	/* C^vg tO NA & 荞݊Jn */
	ApciOutPort(&h8815, APCI8815_INTC_PORT, APCI8815_INTC_RESET);

	return 0;
}

/*============================================================================
//	I
//===========================================================================*/
static void Term8815(void)
{
	int		iVno;
	ushort	wImr;

	/* 荞݋֎~ */
	ApciOutPort(&h8815, APCI8815_INTC_PORT, APCI8815_INTC_RESET);

	iVno = GetVectNo(h8815.bIRQRegisters);		/* 荞ݔԍ擾 */
	wImr = GetImr(h8815.bIRQRegisters);			/* 荞݃}XNWX^擾*/

	disable();
	setvect(iVno, OldVect);						/* 荞݃xN^߂ */
	outportb(wImr, cbOldImr);					/* 荞݋rbg߂ */
	enable();
}

/*============================================================================
//	xN^ԍ擾
//===========================================================================*/
static int GetVectNo(int iIrq)
{
	int Vno;

	if (iIrq < 8)
		Vno = iIrq + IRV_BASE;
	else
		Vno = iIrq + IRVS_BASE - 8;
	return Vno;
}

/*============================================================================
//	IMRAhX擾
//===========================================================================*/
static ushort GetImr(int iIrq)
{
	ushort wImr;

	if (iIrq < 8)
		wImr = IMR;
	else
		wImr = SIMR;
	return wImr;
}

/*============================================================================
//	荞݋rbg擾
//===========================================================================*/
static uchar GetIrqBit(int iIrq)
{
	uchar cbBit;

	if (iIrq < 8)
		cbBit = BIT0 << iIrq;
	else
		cbBit = BIT0 << (iIrq - 8);
	return cbBit;
}

/*============================================================================
//	荞ݏ
//===========================================================================*/
static void interrupt Intr8815(__CPPARGS)
{
	/* STR |[gǂŁACVDF bit ANeBuǂ`FbNB */
	/* ANeBułȂȂÃfoCXɑ΂Ă̊荞݂ł͂ȂƂ*/
	/* B */
	if ((ApciInPort(&h8815, APCI8815_STR_PORT) & APCI8815_STR_CVDF) == 0)
	{
		asm
		{
			pushf
			call	dword ptr OldVect		/* 荞݃xN^R[ */
		}
		return;
	}

	/* CD |[g[h(A/Dϊf[^̓ǂݏo)B */
	InAd.wData = ApciInPort(&h8815, APCI8815_CD_PORT);

	InAd.InFlg = TRUE;					/* 荞ݔtOZbg */

	/* INTC |[gփf[^óA荞ݗv̉sB */
	ApciOutPort(&h8815, APCI8815_INTC_PORT, APCI8815_INTC_RESET);

	if (h8815.bIRQRegisters < 8)		/* gpIRQ8ȉȂ */
		outportb(PIC, EOI);				/* }X^PICEOI */
	else
	{
		outportb(SPIC, EOI);			/* X[uPICEOI */
		outportb(SPIC, 0xb);			/* ISR [h[hZbg */
		if (!inportb(SPIC))				/* X[uPICT[rXH */
			outportb(PIC,EOI);			/* }X^PICEOI */
	}

	/* OgKɂTvOȂăX^[gB */
	if (nSmpMode == APCI8815_MODE_04)
		ApciOutPort(&h8815, APCI8815_CTL_PORT, wCtrl);
}

/*============================================================================
//	TvOp[^ݒ
//===========================================================================*/
static void SetSamplingMode(void)
{
	ushort wCPD_CHA;
	char   bE0, bE1;
	uchar  bTW;

	/* CTL |[gZbg */
	wCtrl = APCI8815_CTL_RESET;
	ApciOutPort(&h8815, APCI8815_CTL_PORT, wCtrl);

	if (nSmpFrstCH != nSmpLastCH)
		wCtrl |= APCI8815_CTL_CISW;	/* `lEI[gECNg */

	/* `lAhX̐ݒ */
	wCPD_CHA = (ushort)((nSmpLastCH << 4) + nSmpFrstCH);

	/* CTL  15-8bit ֓] */
	wCtrl |= (wCPD_CHA << 8);

	/* ^C} */
	if (nSmpMode == APCI8815_MODE_03)
	{
		/* ^C}A/Dϊf[^̈TvO */
		wCtrl |= APCI8815_CTL_SMP;

		bTW = TimerToTWData(&bE0, &bE1);

		if (bE0 == 1)			/* ^C}͎g0 */
			wCtrl |= APCI8815_CTL_E0;

		if (bE1 == 1)			/* ^C}͎g1 */
			wCtrl |= APCI8815_CTL_E1;
	}

	/* OgK */
	if (nSmpMode == APCI8815_MODE_02 || nSmpMode == APCI8815_MODE_04)
		wCtrl |= APCI8815_CTL_EXTSW;

	/* CTL ݒ */
	ApciOutPort(&h8815, APCI8815_CTL_PORT, wCtrl);

	/* TW |[g̐ݒ */
	if (nSmpMode == APCI8815_MODE_03)
		ApciOutPort(&h8815, APCI8815_TW_PORT, bTW);
}

/*============================================================================
// ^C}̃f[^ϊ
//===========================================================================*/
static uchar TimerToTWData(char* pbE0, char* pbE1)
{
	*pbE0 = 0;		/* E0 ^C}͎g0 */
	*pbE1 = 0;		/* E1 ^C}͎g1 */

	/* 12`		 999̏ꍇAi͒l^Sj|P^C}ݒl */
	if (dwSmpTime >=	 12UL && dwSmpTime <=	   999UL)
		return (uchar)(dwSmpTime / 4UL - 1UL);

	/*	 1000`	  249999̏ꍇAi͒l^1000j|P^C}ݒl */
	if (dwSmpTime >=   1000UL && dwSmpTime <=	249999UL)
	{
		*pbE0 = 1;		/* ^C}͎g0 */
		return (uchar)(dwSmpTime / 1000UL - 1UL);
	}

	/* 250000` 64000000̏ꍇAi͒l^250000j|P^C}ݒl */
	if (dwSmpTime >= 250000UL && dwSmpTime <= 64000000UL)
	{
		*pbE1 = 1;		/* ^C}͎g1 */
		return (uchar)(dwSmpTime / 250000UL - 1UL);
	}

	return 0;
}

/*============================================================================
//	TvOJn
//===========================================================================*/
static void StartSampling(void)
{
	if (ApciInPort(&h8815, APCI8815_STR_PORT) & APCI8815_STR_CVDF)
	{
		/* ǂݏo\ԂȂ_~[ǂݍ */
		ApciInPort(&h8815, APCI8815_CD_PORT);
	}

	/* A/DϊX^[g */
	wCtrl |= APCI8815_CTL_START;

	/* CTL ݒ */
	ApciOutPort(&h8815, APCI8815_CTL_PORT, wCtrl);
}

/*============================================================================
//	TvOXgbv
//===========================================================================*/
static void StopSampling(void)
{
	/* A/DϊXgbv */
	wCtrl &= ~APCI8815_CTL_START;

	/* CTL ݒ */
	ApciOutPort(&h8815, APCI8815_CTL_PORT, wCtrl);	/* Xgbv */
}

#if defined(_MSC_VER)
	#if defined(NDEBUG)							/* [X[hRpC*/
		#pragma optimize("", on)				/* ̏Ԃɖ߂ */
	#endif
#endif
