/********************************************************************/
/*																	*/
/*		^`wb_												*/
/*																	*/
/********************************************************************/

#if !defined(_TYPEDEF_H)

#define _TYPEDEF_H

typedef unsigned char		uchar;
typedef unsigned short		ushort;
typedef unsigned long		ulong;

#ifdef __cplusplus
	enum boolean { FALSE, TRUE };
#else
	typedef enum { FALSE, TRUE } boolean;
#endif

/****	BIT`		****/
#define	BIT0			0x1
#define	BIT1			0x2
#define	BIT2			0x4
#define	BIT3			0x8
#define	BIT4			0x10
#define	BIT5			0x20
#define	BIT6			0x40
#define	BIT7			0x80

/****	NEC PC9801 or DOS/V I	****/
#define	_PC_	0			/* 0=DOS/V , 1=PC98 */
#define	EOI	0x20

#if	_PC_ == 0		/* IBM PC/AT  荞ݒ` */
	#define	IRV_BASE	8		/* Ͻ 荞ްԍ */
	#define	IRVS_BASE	0x70	/* ڰ 荞ްԍ */
	#define	PIC			0x20	/* Ͻ 8259 ۸ي荞ݺ۰ׁ@ڽ */
	#define	IMR			0x21	/* Ͻ Ͻڼ޽ ڽ */
	#define	SPIC		0xa0	/* ڰ 8259 ۸ي荞ݺ۰ׁ@ڽ */
	#define	SIMR		0xa1	/* ڰ Ͻڼ޽ ڽ */
#endif

#if _PC_ == 1		/* NEC PC-98  荞ݒ` */
	#define	IRV_BASE	8		/* Ͻ 荞ްԍ */
	#define	IRVS_BASE	0x10	/* ڰ 荞ްԍ */
	#define	PIC			0x0		/* 8259 ۸ي荞ݺ۰ׁ@ڽ */
	#define	IMR			0x2		/* Ͻڼ޽ ڽ */
	#define	SPIC		0x8		/* ڰ 8259 ۸ي荞ݺ۰ׁ@ڽ */
	#define	SIMR		0xa		/* ڰ Ͻڼ޽ ڽ */
#endif

#if defined(_MSC_VER)		/* MSC I */
 #define	asm		_asm
 #define	outportb(x,y)	outp(x,y)
 #define	inportb(x)		inp(x)
 #define	outportw(x, y)	outpw(x, y)				/* [ho */
 #define	inportw(x)		(ushort)inpw(x)			/* [h */
 #define	enable()		_enable()
 #define	disable()		_disable()
 #define	getvect(x)		_dos_getvect(x)
 #define	setvect(x,y)	_dos_setvect(x,y)
 #define	interrupt		_interrupt
 #define	far				_far
 #pragma check_stack(off)
#elif defined(__BORLANDC__) || (__TURBOC__)		/* BCC/TCP I */
 #pragma option -N-				/* BorlandC STACK Ȃ */
 #define	outportw(x, y)	outport(x, (int)y)		/* [ho */
 #define	inportw(x)		(ushort)inport(x)		/* [h */
#endif

#endif

