/*============================================================================
//	aPCI8815 Tv\tgP
//
//	aPCI8815̐ڑ󋵂\
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1998/10/21
//
//	TvF	aPCIhCõT[rX[`̃AhX擾āA
//			aPCI8815̏\܂B
//
//	@@EPCI BIOS̃o[W
//	@@EPnPhCõo[W
//	@@EfoCX ID
//	@@E[ x[X AhX
//	@@E[ EBhE 
//	@@EI/O x[X AhX
//	@@EI/O EBhE 
//	@@EIRQԍ
//
//	@uAPCICTRL.CvƁuSAMPLE1.CvRpC^NĂgpB
//
//	RpC@F
//		TC++4.0̏ꍇ	tcc -ml sample1.c apcictrl.c
//		MS-C6.0̏ꍇ	cl /AL sample1.c apcictrl.c
//
//	ӁF
//	@{vOTC++4.0/MS-C6.0œmFsĂ܂B
//	̑RpCgp̏ꍇ̓TvvȌCKvɂȂꍇ
//	L܂B
//	@{vO͂lr|cnrœ\Ȏst@C𐶐łRpC
//	ł̂݃RpC\łB
//
//===========================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include "typedef.h"
#include "apci8815.h"


/*---------- X^eBbN֐ -----------------------------------------------*/
static ushort  DispDriverVersion(void);
static void	   GetVersionStr(char* buff, ushort ver);
static boolean dispPciInfo(ushort wNum);


/*============================================================================
//	aPCI8815SfoCX̏\
//===========================================================================*/
int main(void)
{
	/* Gg[擾 */
	if (ApciGetDriverFunc() == -1)
	{
		printf( "ײނ̴ذ擾ł܂ł\n" );
		return -1;
	}

	/* hCoo[W\ */
	if (DispDriverVersion() <= 0)
	{
		printf("foCX܂\n");
		return -1;
	}

	dispPciInfo(APCI8815_MAX_SLOTS);		/* PnP\ */

	return 0;
}

/*============================================================================
//		hCȍʕ\
//	߂l	PCI BIOS  1 Ԃ
//			G[Ȃ0Ԃ
//===========================================================================*/
static ushort DispDriverVersion(void)
{
	APCI_VER_RES	rsp;
	char			szBuff[20];
	ushort			result = 0;

	/* ײނ̏Ԏ擾 */
	if (ApciGetVersion((LPAPCI_VER_RES)&rsp) == CMD_COMPLETE)
	{
		if (rsp.wPciBiosVersion != 0)	/* PCI BIOSL */
		{
			/* PCI BIOSްޮ݂\ */
			GetVersionStr(szBuff, rsp.wPciBiosVersion);
			printf("PCI BIOS o[W  %s\n", szBuff);
			result = 1;
		}
		/* PnPhCõo[W\ */
		GetVersionStr(szBuff, rsp.wDriverVersion);
		printf("aPCI hCo[ o[W %s\n", szBuff);
	}
	return result;
}

/*============================================================================
//		o[Wԍ𕶎ɕϊ
//		buff	ϊRs[obt@ւ̃|C^
//			ver		ϊo[Wԍ
//===========================================================================*/
static void GetVersionStr(char* buff, ushort ver)
{
	buff[0] = (char)(ver >> 12) + '0';
	if (buff[0] == '0')
		buff[0] = ' ';
	buff[1] = (char)((ver >> 8) & 0xf) + '0';
	buff[2] = '.';
	buff[3] = (char)((ver >> 4) & 0xf) + '0';
	buff[4] = (char)(ver & 0xf) + '0';
	buff[5] = '\0';
}

/*============================================================================
//		PnPpobt@ gaPnP_rec ɃhCo擾foCX
//			Zbg
//	߂l	foCXTRUEԂ
//===========================================================================*/
static boolean dispPciInfo(ushort wNum)
{
	ushort			i;
	APCI_FIND_RES	rsp;
	ushort			retcode;

	for (i = 0; i < wNum; i++)
	{
		/* foCX擾 */
		retcode = ApciGetDeviceInfo((LPAPCI_FIND_RES)&rsp , APCI8815_BOARD_ID, i);
		if (retcode == CMD_COMPLETE)		/* 擾ł */
		{
			printf("\n_ۯĔԍ    = %d\n", i);
			printf("޲ ID       = %04x\n", rsp.wDeviceID);
			if (rsp.wNumMemWindows > 0)
			{
				printf("ذ ް ڽ = %08lx\n", rsp.dMemBase);
				printf("ذ ީ   = %08lx\n", rsp.dMemLength);
			}
			if (rsp.wNumIOPort > 0)
			{
				printf("I/O ް ڽ  = %04x\n", rsp.wIOPortBase);
				printf("I/O ީ    = %04x\n", rsp.wIOPortLength);
			}
			if (rsp.wNumIRQs > 0)
				printf("IRQԍ         = %d\n", rsp.bIRQRegisters);
		}
		else									/* 擾łȂ */
			break;								/* I */
	}
	return (i == 0) ? FALSE : TRUE;
}
